"use strict";

// These variables exist on the prototype object
const foo = "bar";
let instanceCounter = 0;

module.exports = {

  // These methods exist on the prototype object
  init: function(el) {
    // These variables exist on the object that links to the prototype object
    this.el = el;
    this.el.addEventListener("click", event => {
      // This method does not exist on the object that links to the prototype
      // object, so JavaScript will walk the prototype chain until it finds
      // the method on the linked prototype object
      this.handleClick();
    });
    this.instanceId = instanceCounter;
    instanceCounter++;
  },

  handleClick: function() {
    console.log(this.el);
    console.log(this.instanceId);
  }

};

// The following pattern will not behave as expected when there are multiple
// "instances" because they all share the same "uniqueId", "el", etc.

// const foo = "bar";
// let instanceCounter = 0;
// let uniqueId;
// let el;
//
// function init(elem) {
//   uniqueId = `id${instanceCounter}`;
//   el = elem;
//   el.addEventListener("click", event => {
//     handleClick();
//   });
//   instanceCounter++;
// }
//
// function handleClick() {
//   console.log(el);
//   console.log(uniqueId);
// }
//
// module.exports = {
//   init
// };
